/* client functions auto-generated by pidl */

#include "includes.h"
#include <tevent.h>
#include "lib/util/tevent_ntstatus.h"
#include "bin/default/librpc/gen_ndr/ndr_dfsblobs.h"
#include "bin/default/librpc/gen_ndr/ndr_dfsblobs_c.h"

/* dfsblobs - client functions generated by pidl */

struct dcerpc_dfs_GetDFSReferral_r_state {
	TALLOC_CTX *out_mem_ctx;
};

static void dcerpc_dfs_GetDFSReferral_r_done(struct tevent_req *subreq);

struct tevent_req *dcerpc_dfs_GetDFSReferral_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct dfs_GetDFSReferral *r)
{
	struct tevent_req *req;
	struct dcerpc_dfs_GetDFSReferral_r_state *state;
	struct tevent_req *subreq;

	req = tevent_req_create(mem_ctx, &state,
				struct dcerpc_dfs_GetDFSReferral_r_state);
	if (req == NULL) {
		return NULL;
	}

	state->out_mem_ctx = talloc_new(state);
	if (tevent_req_nomem(state->out_mem_ctx, req)) {
		return tevent_req_post(req, ev);
	}

	subreq = dcerpc_binding_handle_call_send(state, ev, h,
			NULL, &ndr_table_dfsblobs,
			NDR_DFS_GETDFSREFERRAL, state->out_mem_ctx, r);
	if (tevent_req_nomem(subreq, req)) {
		return tevent_req_post(req, ev);
	}
	tevent_req_set_callback(subreq, dcerpc_dfs_GetDFSReferral_r_done, req);

	return req;
}

static void dcerpc_dfs_GetDFSReferral_r_done(struct tevent_req *subreq)
{
	struct tevent_req *req =
		tevent_req_callback_data(subreq,
		struct tevent_req);
	NTSTATUS status;

	status = dcerpc_binding_handle_call_recv(subreq);
	TALLOC_FREE(subreq);
	if (tevent_req_nterror(req, status)) {
		return;
	}

	tevent_req_done(req);
}

NTSTATUS dcerpc_dfs_GetDFSReferral_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx)
{
	struct dcerpc_dfs_GetDFSReferral_r_state *state =
		tevent_req_data(req,
		struct dcerpc_dfs_GetDFSReferral_r_state);
	NTSTATUS status;

	if (tevent_req_is_nterror(req, &status)) {
		tevent_req_received(req);
		return status;
	}

	talloc_steal(mem_ctx, state->out_mem_ctx);

	tevent_req_received(req);
	return NT_STATUS_OK;
}

NTSTATUS dcerpc_dfs_GetDFSReferral_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct dfs_GetDFSReferral *r)
{
	NTSTATUS status;

	status = dcerpc_binding_handle_call(h,
			NULL, &ndr_table_dfsblobs,
			NDR_DFS_GETDFSREFERRAL, mem_ctx, r);

	return status;
}

struct dcerpc_dfs_GetDFSReferral_state {
	struct dfs_GetDFSReferral orig;
	struct dfs_GetDFSReferral tmp;
	TALLOC_CTX *out_mem_ctx;
};

static void dcerpc_dfs_GetDFSReferral_done(struct tevent_req *subreq);

struct tevent_req *dcerpc_dfs_GetDFSReferral_send(TALLOC_CTX *mem_ctx,
						  struct tevent_context *ev,
						  struct dcerpc_binding_handle *h,
						  struct dfs_GetDFSReferral_in _req /* [in]  */,
						  struct dfs_referral_resp *_resp /* [out] [ref] */)
{
	struct tevent_req *req;
	struct dcerpc_dfs_GetDFSReferral_state *state;
	struct tevent_req *subreq;

	req = tevent_req_create(mem_ctx, &state,
				struct dcerpc_dfs_GetDFSReferral_state);
	if (req == NULL) {
		return NULL;
	}
	state->out_mem_ctx = NULL;

	/* In parameters */
	state->orig.in.req = _req;

	/* Out parameters */
	state->orig.out.resp = _resp;

	state->out_mem_ctx = talloc_named_const(state, 0,
			     "dcerpc_dfs_GetDFSReferral_out_memory");
	if (tevent_req_nomem(state->out_mem_ctx, req)) {
		return tevent_req_post(req, ev);
	}

	/* make a temporary copy, that we pass to the dispatch function */
	state->tmp = state->orig;

	subreq = dcerpc_dfs_GetDFSReferral_r_send(state, ev, h, &state->tmp);
	if (tevent_req_nomem(subreq, req)) {
		return tevent_req_post(req, ev);
	}
	tevent_req_set_callback(subreq, dcerpc_dfs_GetDFSReferral_done, req);
	return req;
}

static void dcerpc_dfs_GetDFSReferral_done(struct tevent_req *subreq)
{
	struct tevent_req *req = tevent_req_callback_data(
		subreq, struct tevent_req);
	struct dcerpc_dfs_GetDFSReferral_state *state = tevent_req_data(
		req, struct dcerpc_dfs_GetDFSReferral_state);
	NTSTATUS status;
	TALLOC_CTX *mem_ctx;

	if (state->out_mem_ctx) {
		mem_ctx = state->out_mem_ctx;
	} else {
		mem_ctx = state;
	}

	status = dcerpc_dfs_GetDFSReferral_r_recv(subreq, mem_ctx);
	TALLOC_FREE(subreq);
	if (tevent_req_nterror(req, status)) {
		return;
	}

	/* Copy out parameters */
	*state->orig.out.resp = *state->tmp.out.resp;

	/* Reset temporary structure */
	NDR_ZERO_STRUCT(state->tmp);

	tevent_req_done(req);
}

NTSTATUS dcerpc_dfs_GetDFSReferral_recv(struct tevent_req *req,
					TALLOC_CTX *mem_ctx)
{
	struct dcerpc_dfs_GetDFSReferral_state *state = tevent_req_data(
		req, struct dcerpc_dfs_GetDFSReferral_state);
	NTSTATUS status;

	if (tevent_req_is_nterror(req, &status)) {
		tevent_req_received(req);
		return status;
	}

	/* Steal possible out parameters to the callers context */
	talloc_steal(mem_ctx, state->out_mem_ctx);

	tevent_req_received(req);
	return NT_STATUS_OK;
}

NTSTATUS dcerpc_dfs_GetDFSReferral(struct dcerpc_binding_handle *h,
				   TALLOC_CTX *mem_ctx,
				   struct dfs_GetDFSReferral_in _req /* [in]  */,
				   struct dfs_referral_resp *_resp /* [out] [ref] */)
{
	struct dfs_GetDFSReferral r;
	NTSTATUS status;

	/* In parameters */
	r.in.req = _req;

	/* Out parameters */
	r.out.resp = _resp;

	status = dcerpc_dfs_GetDFSReferral_r(h, mem_ctx, &r);
	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	/* Return variables */
	*_resp = *r.out.resp;

	/* Return result */

	return NT_STATUS_OK;
}

